openapi: 3.0.3
info:
  title: Customers
  contact:
    name: API Support
    url: https://ensi.tech/contacts
    email: mail@greensight.ru
  version: 1.0.0
  description: Управление клиентами
servers:
  - url: /api/v1
tags:
  - name: statuses
    description: Статусы клиентов
  - name: addresses
    description: Адреса клиентов
  - name: customers
    description: Клиенты
paths:
  /customers/customers:search:
    $ref: './customers/customers_paths.yaml#/CustomersSearch'
  /customers/customers:search-one:
    $ref: './customers/customers_paths.yaml#/CustomersSearchOne'
  /customers/customers:
    $ref: './customers/customers_paths.yaml#/Customers'
  /customers/customers:verify-email:
    $ref: './customers/customers_paths.yaml#/CustomersVerifyEmail'
  /customers/customers/{id}:upload-avatar:
    $ref: './customers/customers_paths.yaml#/CustomersUploadAvatar'
  /customers/customers/{id}:delete-avatar:
    $ref: './customers/customers_paths.yaml#/CustomersDeleteAvatar'
  /customers/customers/{id}:delete-personal-data:
    $ref: './customers/customers_paths.yaml#/CustomersDeletePersonalData'
  /customers/customers/{id}:
    $ref: './customers/customers_paths.yaml#/CustomersOne'

  /customers/addresses:search:
    $ref: './customers/customer_addresses_paths.yaml#/CustomerAddressesSearch'
  /customers/addresses:
    $ref: './customers/customer_addresses_paths.yaml#/CustomerAddresses'
  /customers/addresses/{id}:
    $ref: './customers/customer_addresses_paths.yaml#/CustomerAddressesOne'
  /customers/addresses/{id}:set-as-default:
    $ref: './customers/customer_addresses_paths.yaml#/CustomerAddressesSetAsDefault'

  /customers/statuses:search:
    $ref: './customers/customer_statuses_paths.yaml#/CustomerStatusesSearch'
  /customers/statuses:
    $ref: './customers/customer_statuses_paths.yaml#/CustomerStatuses'
  /customers/statuses/{id}:
    $ref: './customers/customer_statuses_paths.yaml#/CustomerStatusesOne'


components:
  parameters:
    QueryInclude:
      $ref: './common_parameters.yaml#/QueryInclude'
    PathId:
      $ref: './common_parameters.yaml#/PathId'
  schemas:
    EmptyDataResponse:
      type: object
      properties:
        data:
          type: object
          nullable: true
        meta:
          type: object
      required:
        - data
    PaginationTypeEnum:
      $ref: './common_schemas.yaml#/PaginationTypeEnum'
    CustomerGenderEnum:
      $ref: './customers/enums/customer_gender_enum.yaml'
    MessageForChangeEmail:
      $ref: './kafka_messages.yaml#/MessageForChangeEmail'
  responses:
    BadRequest:
      description: Bad Request
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
    NotFound:
      description: Not Found
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
    ServerError:
      description: Internal Server Error
      content:
        application/json:
          schema:
            $ref: './errors.yaml#/ErrorResponse'
